﻿#include "stdafx.h"
#include "DuiDefine.h"
#include "Resource.h"
#include "..\..\DuiLib\Utils\WinImplBase.h"
#include "SettingAutoTextPopup.h"

#define kSettingRichEdit _T("setting_rich_edit")
#define kSettingOk		_T("setting_ok")
#define kSettingCancel  _T("setting_cancel")
#define kSettingClose  _T("closebtn")

#define RE_DISABLE_COLOR	RGB(0xb7,0xb8,0xc4)
#define RE_NORMAL_COLOR		RGB(0x80,0x80,0x89)

#define SetControlResourceText(name,id)\
	{CControlUI *p = static_cast<CControlUI*>(m_PaintManager.FindControl(name));  \
	if (p)p->SetText(LoadStringFromResource(id));}

#define SetControlText(name,txt)\
	{CControlUI *p = static_cast<CControlUI*>(m_PaintManager.FindControl(name));  \
	if (p)p->SetText(txt);}


DUI_BEGIN_MESSAGE_MAP(CSettingAutoTextPopup, WindowImplBase, FALSE)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnPrepare)
	DUI_ON_CLICK_CTRNAME(kSettingOk,OnOkButtonClick)
	DUI_ON_CLICK_CTRNAME(kSettingCancel,OnSettingClose)
	DUI_ON_SETFOCUS_CTRNAME(kSettingRichEdit,OnRichEditSetFocus)
	DUI_ON_KILLFOCUS_CTRNAME(kSettingRichEdit,OnRichEditKillFocus)
	DUI_ON_CLICK_CTRNAME(kSettingClose,OnSettingClose)
DUI_END_MESSAGE_MAP()

DUI_BEGIN_CUSTOM_MSG_MAP(CSettingAutoTextPopup)
DUI_END_CUSTOM_MSG_MAP()



CSettingAutoTextPopup::CSettingAutoTextPopup()
{
	m_pRichEdit = NULL;
}

CSettingAutoTextPopup::~CSettingAutoTextPopup()
{

}
LRESULT CSettingAutoTextPopup::OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled = FALSE;
	if (!m_pRichEdit->GetText().IsEmpty()
		&& LoadStringFromResource(IDS_STRING397).Compare(m_pRichEdit->GetText()) != 0
		&& m_strRichEditText.Compare(m_pRichEdit->GetText()) != 0)
	{
		if (IDNO == NMessageBoxEx(GetActiveWindow(), LoadStringFromResource(IDS_STRING473), _T("Ntalk Biz"), MB_YESNO))
		{
			bHandled = TRUE;

			HWND hWndParent = GetWindowOwner(m_hWnd);
			if (::IsWindow(hWndParent))
			{
				::EnableWindow(hWndParent, FALSE);
				SetFocus(m_hWnd);
				m_pRichEdit->SetFocus();
			}
		}
	}
	return 0;
}

LRESULT CSettingAutoTextPopup::OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	LRESULT res = __super::OnLButtonDown(uMsg,wParam,lParam,bHandled);
	::InvalidateRect(m_hWnd,NULL,TRUE);
	return res;
}

LRESULT CSettingAutoTextPopup::OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled = FALSE;
	if (wParam == VK_RETURN)
	{
		m_pRichEdit->ReplaceSel(_T("\r\n"), true);
		bHandled = TRUE;
	}

	return 0;
}

CString& CSettingAutoTextPopup::GetRicheditText()
{
	return m_strRichEditText;
}

void CSettingAutoTextPopup::SetRicheditText(CString &strText)
{
	m_strRichEditText = strText;
}


void CSettingAutoTextPopup::InitWindow()
{
	m_pRichEdit = static_cast<CRichEditUI*>(m_PaintManager.FindControl(kSettingRichEdit));
	
	_ASSERT(m_pRichEdit);
	
	m_pRichEdit->SetLimitText(500);

	SetControlResourceText(kSettingOk,IDS_STRING568);
	SetControlResourceText(kSettingCancel,IDS_STRING569);
	if (m_strRichEditText.IsEmpty())
	{
		m_pRichEdit->SetText(LoadStringFromResource(IDS_STRING397));
		m_pRichEdit->SetTextColor(RE_DISABLE_COLOR);
	}
	else
	{
		SetControlText(kSettingRichEdit,m_strRichEditText);
		m_pRichEdit->SetTextColor(RE_NORMAL_COLOR);
	}

	SetControlResourceText(_T("title_name"),IDS_STRING733);
	SetControlResourceText(_T("lbl_autotext"),IDS_STRING734);

	m_pRichEdit->SetReadOnly(true);
}


LPCTSTR CSettingAutoTextPopup::GetWindowClassName() const
{
	return _T("SettingAutoTextPopup");
}


void CSettingAutoTextPopup::OnRichEditSetFocus(TNotifyUI& msg)
{
	m_pRichEdit->SetTextColor(RE_NORMAL_COLOR);
	if (LoadStringFromResource(IDS_STRING397).Compare(m_pRichEdit->GetText()) == 0)
	{
		m_pRichEdit->SetText(_T(""));
	}

	if (m_pRichEdit->IsReadOnly())
	{
		m_pRichEdit->SetReadOnly(false);
	}
}

void CSettingAutoTextPopup::OnRichEditKillFocus(TNotifyUI& msg)
{
	CString strText = LoadStringFromResource(IDS_STRING397);
	if (m_pRichEdit->GetText().IsEmpty()
		|| strText.Compare(m_pRichEdit->GetText()) == 0)
	{
		m_pRichEdit->SetTextColor(RE_DISABLE_COLOR);
		m_pRichEdit->SetText(strText);
	}
}

void CSettingAutoTextPopup::OnOkButtonClick(TNotifyUI& msg)
{
	if (m_pRichEdit->GetText().IsEmpty()
		|| LoadStringFromResource(IDS_STRING397).Compare(m_pRichEdit->GetText()) == 0)
	{
		NMessageBoxEx(m_hWnd, LoadStringFromResource(IDS_STRING478), _T("Ntalk Biz"), MB_OK);
		return;
	}

	m_strRichEditText = m_pRichEdit->GetText();
	Close(IDOK);
}

void CSettingAutoTextPopup::OnSettingClose(TNotifyUI& msg)
{
	
	Close(IDCANCEL);
}

void CSettingAutoTextPopup::OnPrepare(TNotifyUI& msg)
{
// 	if (m_pRichEdit)
// 	{
// 		m_pRichEdit->SetFocus();
// 	}
}

 
CDuiString CSettingAutoTextPopup::GetSkinFile()
{
	return _T("setting_autotext_popup.xml");
}

CDuiString CSettingAutoTextPopup::GetSkinFolder()
{
	return _T("skin\\nTalkRes");
}





